-> thx-play CLI tool. Should also work on WB1.3

-> you should use 'thxplay', not '*thxplay'
MODULE 'tools/file', '*thxplay', 'arp', 'exec/memory', 'dos/dos'

ENUM ARG_FILES, ARG_NOREP, ARG_FADE

PROC main() HANDLE
  DEF args:PTR TO LONG, rdargs=NIL, file, files:PTR TO LONG

  args := [0,0,0]
  IF KickVersion(36)
    IF rdargs := ReadArgs('PLAYLIST/M,NOREPEAT/S,FADE/S', args, NIL)
    ELSE
      PrintFault(IoErr(), NIL)
    ENDIF
  ELSE
    IF arpbase := OpenLibrary('arp.library', 39)
      GaDS(arg, StrLen(arg), NIL, args, 'PLAYLIST/...,NOREPEAT/S,FADE/S')
    ELSE
      WriteF('Needs arp.library v39\n')
      RETURN 20
    ENDIF
  ENDIF

  IF (thxplaybase := OpenLibrary('thxplay.library', 5)) = NIL
    WriteF('Needs thxplay.library v5\n')
    Raise()
  ENDIF

  IF files := args[ARG_FILES] THEN
    WHILE file := files[]++ DO play(file, args[ARG_NOREP], args[ARG_FADE])

EXCEPT DO
  IF thxplaybase
    ThxFree() -> only free all resources _ONCE_
    CloseLibrary(thxplaybase)
  ENDIF

  IF arpbase THEN CloseLibrary(arpbase)
  IF rdargs  THEN FreeArgs(rdargs)
ENDPROC

PROC play(name, norep, fade)
  DEF mod, vol, sig, cont=TRUE

  mod := readfile(name)
  IF mod = NIL
    WriteF('Can\at read file "\s"\n"', name)
    RETURN
  ENDIF

  WriteF('Now playing "\s".\nPress CTRL-C to skip, CTRL-D to stop. '+
         'CTRL-F will fast-forward.\n', name)

  IF ThxInit(mod)
    WriteF('Can\at start player.\n')
    freefile(mod)
    RETURN
  ENDIF

  -> if we are not to repeat, then set THX to break us at the end.
  IF norep THEN ThxSignalEnd(FindTask(NIL), SIGBREAKF_CTRL_C)

  ThxSetVolume(64)
  ThxPlay() -> start play

  WHILE cont
    sig := Wait(SIGBREAKF_CTRL_C OR SIGBREAKF_CTRL_D OR SIGBREAKF_CTRL_F)
    IF sig AND SIGBREAKF_CTRL_F
      ThxWind(1)
    ELSE
      cont := FALSE
    ENDIF
  ENDWHILE

  IF fade
    FOR vol := 64 TO 0 STEP -1
      WaitTOF()
      ThxSetVolume(vol)
    ENDFOR
  ENDIF

  ThxStop() -> no longer use the mod, we can free the memory.

  freefile(mod)

  -> if CTRL-C, not only exit but also pop out of loop in main()
  IF sig AND SIGBREAKF_CTRL_D THEN Raise()
ENDPROC
